-----------------------------------------------------
----Show us Three Dimensions--STD (Vector SubLib)----
-----------------------------------------------------

local STDV = {}


function STDV.newVector(x,y,z)
	local vec = {x = x, y = y, z = z}
	for k,v in pairs(STDV) do
		if type(v)=="function" and k~="newVector" then
			vec[k] = v
		end
	end
	return vec
end

function STDV.magnitude(vec)
	return math.sqrt(vec.x^2+vec.y^2+vec.z^2)
end

function STDV.add(vec1,vec2)
	return STDV.newVector(vec1.x+vec2.x,vec1.y+vec2.y,vec1.z+vec2.z)
end

function STDV.subtract(vec1,vec2)
	return STDV.newVector(vec1.x-vec2.x,vec1.y-vec2.y,vec1.z-vec2.z)
end

function STDV.scale(vec,origin,scale)
	return STDV.newVector(vec.x+(vec.x-origin.x)*scale, vec.y+(vec.y-origin.y)*scale, vec.z+(vec.z-origin.z)*scale)
end

function STDV.rotateAround(vec,origin,rotvec)
	local nvec = STDV.newVector(vec.x,vec.y,vec.z)
	STD.rotateY(tp,STD.camera,STD.camera.dir.y)
	STD.rotateX(tp,STD.camera,STD.camera.dir.x)
	STD.rotateZ(tp,STD.camera,STD.camera.dir.z)
end

return STDV